# rqlite-fs
rqlite-fs is FUSE-based cluster filesystem, implemented on RQLite.

## 1. Install dependences
```
yum install python3-pip fuse3 fuse3-devel python3-devel
pip3 install rqdb pyfuse3
```

## 2. Configure firewall
```
firewall-cmd --permanent --add-port=4001/tcp
firewall-cmd --permanent --add-port=4002/tcp
```

## 3. Install RQLite
```
cd /opt/
curl -L https://github.com/rqlite/rqlite/releases/download/v8.36.1/rqlite-v8.36.1-linux-amd64.tar.gz -o rqlite-v8.36.1-linux-amd64.tar.gz
tar xvfz rqlite-v8.36.1-linux-amd64.tar.gz
rm rqlite-v8.36.1-linux-amd64.tar.gz
mv rqlite-v8.36.1-linux-amd64 rqlite
cd rqlite
```

## 4. Run RQLite
### 4.1 Values
- $IP is current node's ip address.
- $MASTER_IP is master's ip address.
- $DATA_DIR is directory for RQLite database
- $ID is your node id, starting from 1(master) no n

### 4.2 Master node or single node
```
./rqlited -node-id 1 -http-addr=$IP:4001 -raft-addr=$IP:4002 $DATA_DIR
```

### 4.3 Other nodes
``` 
./rqlited -node-id $ID -http-addr=$IP:4001 -raft-addr=$IP:4002 -join $MASTER_IP:4002 $DATA_DIR
```


## 5 Run rqlite-fs
### 5.1 Values
- $IP is current node's ip address.
- $MP is mountpoint

### 5.2 Start
```
./rqlitefs $IP:4001 $MP
```